<?php
#
# Copyright (c) 2010-2013 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
# Plugin: check_diskio
#

$k=1;
$ds_name[$k]='Bytes/second';
$opt[$k] = 
  "--vertical-label \"B/s\" --title \"Disk transfer for $hostname / $servicedesc\" ";
$def[$k] = "DEF:read=$rrdfile:$DS[1]:AVERAGE " ;
$def[$k] .= "DEF:write=$rrdfile:$DS[2]:AVERAGE " ;
$def[$k] .= "CDEF:read_d=read,UN,0,read,IF,60,* " ;
$def[$k] .= "CDEF:write_d=write,UN,0,write,IF,60,* " ;
$def[$k] .= "CDEF:read_s=PREV,UN,read_d,PREV,IF,read_d,+ " ;
$def[$k] .= "CDEF:write_s=PREV,UN,write_d,PREV,IF,write_d,+ " ;
$def[$k] .= "LINE1:read#00CC00:\"Read \" " ;
$def[$k] .= "GPRINT:read:LAST:\"%7.2lf %sB/s last\" " ;
$def[$k] .= "GPRINT:read:AVERAGE:\"%7.2lf %sB/s avg\" " ;
$def[$k] .= "GPRINT:read:MAX:\"%7.2lf %sB/s max\" " ;
$def[$k] .= "GPRINT:read_s:MAX:\"%7.2lf %sB total\\n\" " ; 
$def[$k] .= "LINE1:write#CC0000:\"Write\" " ;
$def[$k] .= "GPRINT:write:LAST:\"%7.2lf %sB/s last\" " ;
$def[$k] .= "GPRINT:write:AVERAGE:\"%7.2lf %sB/s avg\" " ;
$def[$k] .= "GPRINT:write:MAX:\"%7.2lf %sB/s max\" ";
$def[$k] .= "GPRINT:write_s:MAX:\"%7.2lf %sB total\\n\" ";

if (isset($UNIT[4])) {
  $k+=1;

  $ds_name[$k]='IO/second';
  $opt[$k] = 
    "--vertical-label \"IO/s\" --title \"Disk IO for $hostname / $servicedesc\" ";
  $def[$k] = "DEF:ioread=$rrdfile:$DS[3]:AVERAGE " ;
  $def[$k] .= "DEF:iowrite=$rrdfile:$DS[4]:AVERAGE " ;
  $def[$k] .= "CDEF:ioread_d=ioread,UN,0,ioread,IF,60,* " ;
  $def[$k] .= "CDEF:iowrite_d=iowrite,UN,0,iowrite,IF,60,* " ;
  $def[$k] .= "CDEF:ioread_s=PREV,UN,ioread_d,PREV,IF,ioread_d,+ " ;
  $def[$k] .= "CDEF:iowrite_s=PREV,UN,iowrite_d,PREV,IF,iowrite_d,+ " ;
  $def[$k] .= "LINE1:ioread#00CC00:\"IO Read \" " ;
  $def[$k] .= "GPRINT:ioread:LAST:\"%7.2lf %s/s last\" " ;
  $def[$k] .= "GPRINT:ioread:AVERAGE:\"%7.2lf %s/s avg\" " ;
  $def[$k] .= "GPRINT:ioread:MAX:\"%7.2lf %s/s max\" " ;
  $def[$k] .= "GPRINT:ioread_s:MAX:\"%7.2lf %s total\\n\" " ; 
  $def[$k] .= "LINE1:iowrite#CC0000:\"IO Write\" " ;
  $def[$k] .= "GPRINT:iowrite:LAST:\"%7.2lf %s/s last\" " ;
  $def[$k] .= "GPRINT:iowrite:AVERAGE:\"%7.2lf %s/s avg\" " ;
  $def[$k] .= "GPRINT:iowrite:MAX:\"%7.2lf %s/s max\" ";
  $def[$k] .= "GPRINT:iowrite_s:MAX:\"%7.2lf %s total\\n\" ";

  $last_ds = $DS[5];
} else {
  $last_ds = $DS[3];
}

$k+=1;
$ds_name[$k]='Time in queue';
$opt[$k] = 
  "--vertical-label \"s\" --title \"Queue time for $hostname / $servicedesc\" ";
$def[$k] = "DEF:var1=$rrdfile:$last_ds:AVERAGE " ;
$def[$k] .= "LINE1:var1#0000CC:\"Time in queue\" " ;
$def[$k] .= "GPRINT:var1:LAST:\"%7.2lf %s last\" " ;
$def[$k] .= "GPRINT:var1:AVERAGE:\"%7.2lf %s avg\" " ;
$def[$k] .= "GPRINT:var1:MAX:\"%7.2lf %s max\\n\" " ;

?>
