<?php
#
# Copyright (c) 2009-2014 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
# Plugin: check_mysql_perf
#

$ds_name[1]='Questions';
$opt[1] = "--vertical-label \"$ds_name[1]/s\" --title \"SQL questions for $hostname / $servicedesc\" ";
$def[1] = "DEF:pvar1=$rrdfile:$DS[1]:AVERAGE " ;
$def[1] .= "DEF:pvar2=$rrdfile:$DS[2]:AVERAGE " ;
$def[1] .= "CDEF:var1=pvar1,0,MAX " ;
$def[1] .= "CDEF:var2=pvar2,0,MAX " ;
$def[1] .= "LINE1:var1#00CC00:\"$ds_name[1]   \" " ;
$def[1] .= "GPRINT:var1:LAST:\"%7.2lf %s last\" " ;
$def[1] .= "GPRINT:var1:AVERAGE:\"%7.2lf %s avg\" " ;
$def[1] .= "GPRINT:var1:MAX:\"%7.2lf %s max\\n\" " ;
$def[1] .= "LINE1:var2#CC0000:\"Slow queries\" " ;
$def[1] .= "GPRINT:var2:LAST:\"%7.2lf %s last\" " ;
$def[1] .= "GPRINT:var2:AVERAGE:\"%7.2lf %s avg\" " ;
$def[1] .= "GPRINT:var2:MAX:\"%7.2lf %s max\\n\" ";

function gen($gen_ds, $gen_name, $rrdfile, $hostname, $servicedesc) {
  return "DEF:pvar1=$rrdfile:$gen_ds:AVERAGE "
       . "CDEF:var1=pvar1,0,MAX "
       . "AREA:var1#EACC00:\"$gen_name\" "
       . "LINE1:var1#000000:\"\" "
       . "GPRINT:var1:LAST:\"%7.2lf %s last\" "
       . "GPRINT:var1:AVERAGE:\"%7.2lf %s avg\" "
       . "GPRINT:var1:MAX:\"%7.2lf %s max\\n\" " ;
}

$ds_name[2] = "Opens";
$opt[2] = "--vertical-label \"$ds_name[2]\" --title \"$ds_name[2] for $hostname / $servicedesc\" ";
$def[2] = gen("$DS[3]", "$ds_name[2]", $rrdfile, $hostname, $servicedesc);

$ds_name[3] = "Flush tables";
$opt[3] = "--vertical-label \"$ds_name[3]\" --title \"$ds_name[3] for $hostname / $servicedesc\" ";
$def[3] = gen("$DS[4]", "$ds_name[3]", $rrdfile, $hostname, $servicedesc);

$ds_name[4] = "Open tables";
$opt[4] = "--vertical-label \"$ds_name[4]\" --title \"$ds_name[4] for $hostname / $servicedesc\" ";
$def[4] = gen("$DS[5]", "$ds_name[4]", $rrdfile, $hostname, $servicedesc);

$ds_name[5] = "Threads";
$opt[5] = "--vertical-label \"$ds_name[5]\" --title \"$ds_name[5] for $hostname / $servicedesc\" ";
$def[5] = gen("$DS[6]", "$ds_name[5]", $rrdfile, $hostname, $servicedesc);

?>
